output application/json
import * from bat::Types

ns bat http://mulesoft.com/ns/bat

var testIdSplit = (payload.metadata.testId default '') splitBy ":"

fun processHttp(httpCall: BATPassCapable<Any>, suite: String, scenario: String) = {
// TODO: Validate null optional fields
  time: httpCall.startDate default payload.startDae default now(),
  name: httpCall.name default 'Test name',
  executionId: payload.metadata.executionId default '',
  executionNumber: (payload.metadata.executionNumber default 0) as Number,
  groupId: testIdSplit[0] default '',
  assetId: testIdSplit[1] default '',
  version: testIdSplit[2] default '',
  targetId: payload.metadata.targetId default '',
  organizationId: payload.metadata.organizationId default '',
  configurationId: payload.metadata.configurationId default '',
  url: httpCall.result.request.url default '',
  path: httpCall.result.request.path default '',
  env: payload.parameters.env default 'default',
  method: httpCall.result.request.method,
  status: httpCall.result.response.status,
  filepath: '-',
  suite: suite default 'Suite',
  scenario: scenario default 'Scenario',
  pass: httpCall.pass,
  timers: ensureTimers(httpCall.result.timers)
}

// TODO: Missing values must not be sent
fun ensureTimers(timers) = {
  blocked: timers.blocked default 0,
  dns: timers.dns default 0,
  connect: timers.connect default 0,
  send: timers.send default 0,
  waitTime: timers.waitTime default 0,
  receive: timers.receive default 0,
  ssl: timers.ssl default 0,
  total: timers.total default 0
}

fun processSuite(elem) = do {
  flatten(elem.result map print($, elem.name, elem.name))
}

fun processTest(elem: BATPassCapable<Any>, suite: String, classname: String = '') = do {
  var package = elem.name
  var head = if(classname == '') '' else (classname ++ ' ❯ ')
  ---
  if(elem.prefix == "SUITE")
    processSuite(elem)
  else
    flatten(elem.result map print($, suite, head ++ package))
}

fun print(elem, suite: String = payload.name, classname: String = '') =
  elem match {
    case passCapable if passCapable is BATPassCapable<Any> ->
      passCapable.kind match {
        case "TEST"  -> processTest(passCapable, suite, classname)
        case "HTTP"  -> processHttp(passCapable, suite, classname)
        case "LOOPABLE" -> processTest(passCapable, suite, classname)
        else -> []
      }
    else -> using(yy = log('No match for', elem)) {}
  }

---
flatten(print(payload))



